<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use BillbeeDe\BillbeeAPI\Client;
use BillbeeDe\BillbeeAPI\Response\GetProductsResponse;
use Illuminate\Support\Facades\Http;
use App\Models\ProductInqury;
use App\Jobs\SendInqueryJob;
use App\Models\ProductInqueryReason;
use App\Jobs\SendProductReasonInqueryJob;

class BillbeeController extends BaseController
{
    public function vapiWebhookResponses(Request $request)
    {
        return response()->json([
            "results" => [
                [
                    // "toolCallId" => $tool_call_id,
                    // "result" => $message
                ]
            ]
        ], 200);

        $data = $request->all();

        \Log::info('Received Webhook Data', [$data]);
        $tool_call_id = $data['message']['toolCalls'][0]['id'];

        if (
            isset($data['message']['toolCalls'][0]['function']['name']) &&
            $data['message']['toolCalls'][0]['function']['name'] === 'fetchOrderDetails'
        ) {

            $order_id = $data['message']['toolCalls'][0]['function']['arguments']['order_id'];

            \Log::info('Order ID PROPER EGT DONE', [$order_id, $tool_call_id]);

            return $this->getOrder($order_id, $tool_call_id);
        } else {

            return $this->sendResponse($tool_call_id, 'The provided Order ID is incorrect. Please provide a valid Order ID.');
        }
    }

    public function getAllOrders(Request $request)
    {

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders?page=416');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        $headers = array();


        $headers[] = 'Authorization: Basic ' . base64_encode('info@tilltools.de:kadfniHu7894*!');
        $headers[] = 'Content-Type: application/json';
        $headers[] = 'X-Billbee-Api-Key: 21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8';
        $headers[] = 'Accept: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return json_decode($result);
    }

    // public function getOrderDetails(Request $request)
    // {
    //     \Log::info('API hit ho gai he');

    //     // if (!$id || !is_numeric($id)) {
    //     //     return $this->sendResponse($tool_call_id, 'Please provide Order ID.');
    //     // }
    //     $id = $request->id;

    //     $username = env('BILLBEE_USERNAME', 'info@tilltools.de');
    //     $password = env('BILLBEE_PASSWORD', 'kadfniHu7894*!');
    //     $apiKey = env('BILLBEE_API_KEY', '21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8');

    //     $ch = curl_init();

    //     curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders/findbyextref/' . $id);
    //     curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    //     curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
    //     curl_setopt($ch, CURLOPT_TIMEOUT, 30); // Add timeout
    //     curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true); // Verify SSL for security

    //     $headers = [
    //         'Authorization: Basic ' . base64_encode($username . ':' . $password),
    //         'X-Billbee-Api-Key: ' . $apiKey,
    //         'Content-Type: application/json',
    //         'Accept: application/json'
    //     ];
    //     curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    //     $result = curl_exec($ch);
    //     $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

    //     $response = json_decode($result, true);
    //     $data = $response['Data'];
    //     // return $data;


    //     // // Check for errors
    //     // if (curl_errno($ch)) {
    //     //     $error = curl_error($ch);
    //     //     curl_close($ch);
    //     //     \Log::error('Billbee API cURL error:', ['error' => $error, 'order_id' => $id]);

    //     //     return $this->sendResponse($tool_call_id, 'The provided Order ID is incorrect. Please provide a valid Order ID.');
    //     // }

    //     curl_close($ch);



    //     // if ($response === null) {
    //     //     \Log::error('Billbee API invalid response:', ['order_id' => $id]);
    //     //     return $this->sendResponse($tool_call_id, 'The provided Order ID is incorrect. Please provide a valid Order ID.');
    //     // }

    //     // \Log::info('REPONSEIS ->>>>>    aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa', [$response]);

    //     $orderItems = $response['Data']['OrderItems'][0] ?? null;

    //     if ($orderItems) {
    //         $message = [
    //             'OrderNumber' => $data['OrderNumber'],
    //             'Customer Name' => $data['Customer']['Name'],
    //             'Company Name' => $data['InvoiceAddress']['Company'],
    //             'Shipping Address' => $data['ShippingAddress']['Street'] . " " . $data['ShippingAddress']['HouseNumber'] . " " . $data['ShippingAddress']['Zip'] . " " . $data['ShippingAddress']['City'] . " " . $data['ShippingAddress']['Country'],
    //             'Email' =>     $data['Customer']['Email'],
    //             'Phone Number' => $data['Customer']['Tel1'],
    //             'Total Cost' => $data['TotalCost'],
    //             'OrderItems Description' => $data['OrderItems']['Product']['Title'],
    //             'SKU' => $data['OrderItems']['Product']['SKU'],
    //             'ShippingCost' => $data['ShippingCost'],
    //             'Tax Amount' => $data['OrderItems']['TaxAmount'],
    //             'ShippingIds' => $data['ShippingIds']['ShippingId'],
    //             'PaidAmount' =>  $data['PaidAmount'],
    //             'Invoice Number' => $data['InvoiceNumber'],
    //         ];
    //     } else {
    //         // return $this->sendResponse($tool_call_id, 'The provided Order ID is incorrect. Please provide a valid Order ID.');
    //     }

    //     \Log::info('Data Response RIGHT BBBBBBBBBBBBB', $message);

    //     return $this->sendResponse($message);
    // }

    public function getOrderDetails(Request $request)
    {
        $data = $request->all();

        \Log::info('Received API HIT Data', [$data]);

        $tool_call_id = $data['message']['toolCalls'][0]['id'];
        $order_id = $data['message']['toolCalls'][0]['function']['arguments']['order_id'];


        // Billbee API credentials
        $username = env('BILLBEE_USERNAME', 'info@tilltools.de');
        $password = env('BILLBEE_PASSWORD', 'kadfniHu7894*!');
        $apiKey = env('BILLBEE_API_KEY', '21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8');

        // API request setup
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://app.billbee.io/api/v1/orders/findbyextref/$order_id");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Authorization: Basic ' . base64_encode("$username:$password"),
            'X-Billbee-Api-Key: ' . $apiKey,
            'Content-Type: application/json',
            'Accept: application/json'
        ]);

        $result = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $error = curl_error($ch);
        curl_close($ch);

        // Handle curl errors
        if ($error) {
            \Log::error("Billbee API cURL error: $error", ['order_id' => $order_id]);
            return $this->sendResponse($tool_call_id, 'Invalid Order ID or no data found.');
        }

        // Decode response
        $response = json_decode($result, true);
        if (!$response || !isset($response['Data'])) {
            \Log::error('Invalid API response from Billbee.', ['order_id' => $order_id]);
            return $this->sendResponse($tool_call_id, 'Invalid Order ID or no data found');
        }

        $data = $response['Data'];
        // return $data;
        $message = [
            'Order Number' => $data['OrderNumber'] ?? 'N/A',
            'Customer Name' => optional($data['Customer'])['Name'] ?? 'N/A',
            'Company Name' => optional($data['InvoiceAddress'])['Company'] ?? 'N/A',
            'Shipping Address' => optional($data['ShippingAddress'])['Street'] . ' ' . optional($data['ShippingAddress'])['HouseNumber'] . ', ' . optional($data['ShippingAddress'])['Zip'] . ' ' . optional($data['ShippingAddress'])['City'] . ', ' . optional($data['ShippingAddress'])['Country'],
            'Email' => optional($data['Customer'])['Email'] ?? 'N/A',
            'Phone Number' => optional($data['Customer'])['Tel1'] ?? 'N/A',
            'Total Cost' => $data['TotalCost'] ?? 0.00,
            'ShippingCost' => $data['ShippingCost'] ?? 0.00,
            'ShippingIds' => $data['ShippingIds'][0]['ShippingId'] ?? 'N/A',
            'Shipped Date' => $data['ShippingIds'][0]['Created'] ?? 'N/A',
            'Shipper Name' =>  $data['ShippingIds'][0]['Shipper'] ?? 'N/A',
            'PaidAmount' => $data['PaidAmount'] ?? 0.00,
            'Invoice Number' => $data['InvoiceNumber'] ?? 'N/A',
            'Postal code' => optional($data['ShippingAddress'])['Zip'] ?? 'N/A',

            'OrderItems' => []

            // 'OrderItems Description' => optional(optional($data['OrderItems'])[0]['Product'])['Title'] ?? 'N/A',
            // 'SKU' => optional(optional($data['OrderItems'])[0]['Product'])['SKU'] ?? 'N/A',
            // 'Tax Amount' => optional(optional($data['OrderItems'])[0])['TaxAmount'] ?? 0.00,

        ];

        foreach ($data['OrderItems'] ?? [] as $item) {
            $message['OrderItems'][] = [
                'Description' => optional($item['Product'])['Title'] ?? 'N/A',
                'SKU' => optional($item['Product'])['SKU'] ?? 'N/A',
                'Total Price' => $item['TotalPrice'] ?? 0.00,
                'Quantity' => $item['Quantity'] ?? 0.00,
                'Tax Amount' => $item['TaxAmount'] ?? 0.00,
            ];
        }

        \Log::info('Order details retrieved successfully.', [$message]);
        // return $message;

        return $this->sendResponse($tool_call_id, $message);
    }

    public function createProductInquiry(Request $request)
    {
        $data = $request->all();

        \Log::info('Received Webhook Data FOR CREAT INQUERY', [$data]);

        $tool_call_id = $data['message']['toolCalls'][0]['id'];
        \Log::info('make INUQUER', [json_decode($request)]);

        if (
            isset($data['message']['toolCalls'][0]['function']['name']) &&
            $data['message']['toolCalls'][0]['function']['name'] === 'createProductInquiry'
        ) {

            $name = $data['message']['toolCalls'][0]['function']['arguments']['name'];
            $phone_number = $data['message']['toolCalls'][0]['function']['arguments']['phone_number'];
            $email = $data['message']['toolCalls'][0]['function']['arguments']['email'];

            $product_name = $data['message']['toolCalls'][0]['function']['arguments']['product_name'];

            $company = $data['message']['toolCalls'][0]['function']['arguments']['company'];

            $createProductInqury = ProductInqury::create([
                'name' => $name,
                'email' => $email,
                'phone_number' => $phone_number,
                'company' => $company,
                'product_name' => $product_name,
            ]);

            \Log::info('CRAETED DONE', [$createProductInqury]);

            $admin_email = 'bhaviksamcom7@gmail.com';

            SendInqueryJob::dispatch($createProductInqury, $admin_email);

            return $this->sendResponse($tool_call_id, 'Your Inquery Craete Succefully done');
        } else {
            return $this->sendResponse($tool_call_id, 'The provided Order ID is incorrect. Please provide a valid Order ID.');
        }
    }

    public function createOrderRelatedInquiry(Request $request)
    {
        $data = $request->all();

        \Log::info('Received Webhook ORDER INQUERY<<<<<', [$data]);

        $tool_call_id = $data['message']['toolCalls'][0]['id'];
        \Log::info('make INUQUER', [$tool_call_id]);


        if (
            isset($data['message']['toolCalls'][0]['function']['name']) &&
            $data['message']['toolCalls'][0]['function']['name'] === 'createOrderRelatedInquiry'
        ) {
            $reason = $data['message']['toolCalls'][0]['function']['arguments']['reason'];
            $order_id = $data['message']['toolCalls'][0]['function']['arguments']['order_id'];


            $createInqueryReason = ProductInqueryReason::create([
                'order_id' => $order_id,
                'reason' => $reason,
            ]);

            \Log::info('CRAETED DONE Order Inquery Reason', [$createInqueryReason]);

            $admin_email = 'bhaviksamcom7@gmail.com';

            SendProductReasonInqueryJob::dispatch($createInqueryReason, $admin_email);

            return $this->sendResponse($tool_call_id, 'Your Order Inquery Reason Craete Succefully done');
        } else {
            return $this->sendResponse($tool_call_id, 'The provided Order ID is incorrect. Please provide a valid Order ID.');
        }
    }








































































































































    public function getOrder111($id)
    {
        \Log::info('API hit ho gai he');
        if (!$id || !is_numeric($id)) {
            return response()->json([
                'error' => true,
                'message' => 'Valid order ID is required'
            ], 400);
        }

        $username = env('BILLBEE_USERNAME', 'info@tilltools.de');
        $password = env('BILLBEE_PASSWORD', 'kadfniHu7894*!');
        $apiKey = env('BILLBEE_API_KEY', '21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8');

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders/findbyextref/' . $id);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
        curl_setopt($ch, CURLOPT_TIMEOUT, 30); // Add timeout
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true); // Verify SSL for security

        $headers = [
            'Authorization: Basic ' . base64_encode($username . ':' . $password),
            'X-Billbee-Api-Key: ' . $apiKey,
            'Content-Type: application/json',
            'Accept: application/json'
        ];
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        // Check for errors
        if (curl_errno($ch)) {
            $error = curl_error($ch);
            curl_close($ch);
            \Log::error('Billbee API cURL error:', ['error' => $error, 'order_id' => $id]);
            return response()->json([
                'error' => true,
                'message' => 'API request failed: ' . $error
            ], 500);
        }

        curl_close($ch);

        $response = json_decode($result, true);

        if ($httpCode >= 400) {
            $errorMessage = isset($response->ErrorMessage) ? $response->ErrorMessage : 'Unknown error';
            \Log::error('Billbee API error:', [
                'code' => $httpCode,
                'message' => $errorMessage,
                'order_id' => $id
            ]);

            if ($httpCode == 404) {
                return response()->json([
                    'error' => true,
                    'message' => 'Order not found'
                ], 404);
            }

            return response()->json([
                'error' => true,
                'message' => $errorMessage
            ], $httpCode);
        }


        if ($response === null) {
            \Log::error('Billbee API invalid response:', ['order_id' => $id]);
            return response()->json([
                'error' => true,
                'message' => 'Invalid API response'
            ], 500);
        }
        \Log::info('REPONSEIS ->>>>>    aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa', [$response]);

        $data = $response['Data'];
        $message = [
            'Order Number' => $data['OrderNumber'] ?? 'N/A',
            'Customer Name' => optional($data['Customer'])['Name'] ?? 'N/A',
            'Company Name' => optional($data['InvoiceAddress'])['Company'] ?? 'N/A',
            'Shipping Address' => optional($data['ShippingAddress'])['Street'] . ' ' . optional($data['ShippingAddress'])['HouseNumber'] . ', ' . optional($data['ShippingAddress'])['Zip'] . ' ' . optional($data['ShippingAddress'])['City'] . ', ' . optional($data['ShippingAddress'])['Country'],
            'Email' => optional($data['Customer'])['Email'] ?? 'N/A',
            'Phone Number' => optional($data['Customer'])['Tel1'] ?? 'N/A',
            'Total Cost' => $data['TotalCost'] ?? 0.00,
            'ShippingCost' => $data['ShippingCost'] ?? 0.00,
            'ShippingIds' => $data['ShippingIds'][0]['ShippingId'] ?? 'N/A',
            'Shipped Date' => $data['ShippingIds'][0]['Created'] ?? 'N/A',
            'Shipper Name' =>  $data['ShippingIds'][0]['Shipper'] ?? 'N/A',
            'PaidAmount' => $data['PaidAmount'] ?? 0.00,
            'Invoice Number' => $data['InvoiceNumber'] ?? 'N/A',
            'Postal code' => optional($data['ShippingAddress'])['Zip'] ?? 'N/A',

            'OrderItems' => []

            // 'OrderItems Description' => optional(optional($data['OrderItems'])[0]['Product'])['Title'] ?? 'N/A',
            // 'SKU' => optional(optional($data['OrderItems'])[0]['Product'])['SKU'] ?? 'N/A',
            // 'Tax Amount' => optional(optional($data['OrderItems'])[0])['TaxAmount'] ?? 0.00,

        ];


        foreach ($data['OrderItems'] ?? [] as $item) {
            $message['OrderItems'][] = [
                'Description' => optional($item['Product'])['Title'] ?? 'N/A',
                'SKU' => optional($item['Product'])['SKU'] ?? 'N/A',
                'Tax Amount' => $item['TaxAmount'] ?? 0.00,
            ];
        }

        \Log::info('Order details retrieved successfully.', [$message]);


        // return response()->json([
        //     "results" => [
        //         [
        //             // "toolCallId" => $tool_call_id,
        //             "result" => $message
        //         ]
        //     ]
        // ], 200);


        return response()->json([
            "results" => [
                [
                    // "toolCallId" => $tool_call_id,
                    "result" => $response
                ]
            ]
        ], 200);
    }


    
}




















     // return response()->json([
        //     "results" => [
        //         [
        //             "toolCallId" => $tool_call_id,
        //             "result" => $message
        //         ]
        //     ]
        // ], 200);






    // public function getOrder($id)
    // {
    //     $ch = curl_init();

    //     curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders/' . $id);
    //     curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    //     curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

    //     $headers = array();


    //     $headers[] = 'Authorization: Basic ' . base64_encode('info@tilltools.de:kadfniHu7894*!');
    //     $headers[] = 'Content-Type: application/json';
    //     $headers[] = 'X-Billbee-Api-Key: 21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8';
    //     $headers[] = 'Accept: application/json';
    //     curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    //     $result = curl_exec($ch);
    //     if (curl_errno($ch)) {
    //         echo 'Error:' . curl_error($ch);
    //     }
    //     curl_close($ch);

    //     return json_decode($result);
    // }
