<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use BillbeeDe\BillbeeAPI\Client;
use BillbeeDe\BillbeeAPI\Response\GetProductsResponse;
use App\Traits\Billbee;
use BillbeeAPI\RestClient;

class TestController extends Controller
{
    use Billbee;
    public function getOrders()
    {
        return $this->billbee()->getOrders();
    }

    public function testtest(Request $request){

        try {
            // Get SDK response with proper handling
            $sdkResponse = $this->handleSdkResponse(
                $this->billbee()
                    ->products()
                    ->getProducts(1, 10)
            );

            // Get raw response for comparison
            $rawResponse = $this->billbeeRaw('products', 'GET', [
                'page' => 1,
                'pageSize' => 10
            ]);

            return [
                'sdk_response' => $sdkResponse,
                'raw_response' => $rawResponse,
                'sdk_response_type' => is_object($sdkResponse) ? get_class($sdkResponse) : gettype($sdkResponse)
            ];
        } catch (\Exception $e) {
            return [
                'error' => $e->getMessage(),
                'trace' => $e->getTraceAsString()
            ];
        }

    }

    public function testtest2(Request $request){
        // Generated by curl-to-PHP: http://incarnate.github.io/curl-to-php/
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/products');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');


        $headers = array();


        $headers[] = 'Authorization: Basic ' . base64_encode('info@tilltools.de:kadfniHu7894*!');
        $headers[] = 'Content-Type: application/json';
        $headers[] = 'X-Billbee-Api-Key: 21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8';
        $headers[] = 'Accept: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);


        return json_decode($result);
    }

}
