<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use BillbeeDe\BillbeeAPI\Client;
use BillbeeDe\BillbeeAPI\Response\GetProductsResponse;
use Illuminate\Support\Facades\Http;


class BillbeeController extends Controller
{


    // public function vapiWebhookResponses(Request $request)
    // {
    //     $data = $request->all();
    //     \Log::info('Received Webhook Data', [$data]);
    //     $data['message']['toolCalls'][0]['function']['name'] == 'fetchOrderDetails'
    //     fetchOrderDetails
    //     $order_id = $data['message']['toolCalls'][0]['function']['arguments']['order_id'];

    //     $tool_call_id = $data['message']['toolCalls'][0]['id'];

    //     \Log::info('Ordr ID PROPER EGT DONE', [$order_id, $tool_call_id]);

    //     return $this->getOrder($order_id, $tool_call_id);
    // }




    public function vapiWebhookResponses(Request $request)
    {
        $data = $request->all();

        \Log::info('Received Webhook Data', [$data]);

        if (
            isset($data['message']['toolCalls'][0]['function']['name']) &&
            $data['message']['toolCalls'][0]['function']['name'] === 'fetchOrderDetails'
        ) {

            $order_id = $data['message']['toolCalls'][0]['function']['arguments']['order_id'];
            $tool_call_id = $data['message']['toolCalls'][0]['id'];

            \Log::info('Order ID PROPER EGT DONE', [$order_id, $tool_call_id]);

            return $this->getOrder($order_id, $tool_call_id);
        } elseif (
            isset($data['message']['toolCalls'][0]['function']['name']) &&
            $data['message']['toolCalls'][0]['function']['name'] === 'fetchOrderDetaasassasasails'
        ) {
        } else {
            return response()->json(['message' => 'No action taken'], 200);
        }
    }



    public function getAllOrders(Request $request)
    {

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders');
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

        $headers = array();


        $headers[] = 'Authorization: Basic ' . base64_encode('info@tilltools.de:kadfniHu7894*!');
        $headers[] = 'Content-Type: application/json';
        $headers[] = 'X-Billbee-Api-Key: 21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8';
        $headers[] = 'Accept: application/json';
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
        curl_close($ch);

        return json_decode($result);
    }

    public function getOrder($id, $tool_call_id)
    {
        \Log::info('API hit ho gai he');
        if (!$id || !is_numeric($id)) {
            return response()->json([
                'error' => true,
                'message' => 'Valid order ID is required'
            ], 400);
        }

        $username = env('BILLBEE_USERNAME', 'info@tilltools.de');
        $password = env('BILLBEE_PASSWORD', 'kadfniHu7894*!');
        $apiKey = env('BILLBEE_API_KEY', '21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8');

        $ch = curl_init();

        curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders/' . $id);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
        curl_setopt($ch, CURLOPT_TIMEOUT, 30); // Add timeout
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true); // Verify SSL for security

        $headers = [
            'Authorization: Basic ' . base64_encode($username . ':' . $password),
            'X-Billbee-Api-Key: ' . $apiKey,
            'Content-Type: application/json',
            'Accept: application/json'
        ];
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        $result = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        // Check for errors
        if (curl_errno($ch)) {
            $error = curl_error($ch);
            curl_close($ch);
            \Log::error('Billbee API cURL error:', ['error' => $error, 'order_id' => $id]);
            return response()->json([
                'error' => true,
                'message' => 'API request failed: ' . $error
            ], 500);
        }

        curl_close($ch);

        $response = json_decode($result, true);

        if ($httpCode >= 400) {
            $errorMessage = isset($response->ErrorMessage) ? $response->ErrorMessage : 'Unknown error';
            \Log::error('Billbee API error:', [
                'code' => $httpCode,
                'message' => $errorMessage,
                'order_id' => $id
            ]);

            if ($httpCode == 404) {
                return response()->json([
                    'error' => true,
                    'message' => 'Order not found'
                ], 404);
            }

            return response()->json([
                'error' => true,
                'message' => $errorMessage
            ], $httpCode);
        }


        if ($response === null) {
            \Log::error('Billbee API invalid response:', ['order_id' => $id]);
            return response()->json([
                'error' => true,
                'message' => 'Invalid API response'
            ], 500);
        }
        \Log::info('REPONSEIS ->>>>>    aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa', [$response]);

        // $orderItems = $response['Data']['OrderItems'];

        // $message = "Your order has been successfully processed! Here are the details:\n\n";

        // foreach ($orderItems as $item) {
        //     $message .= "Product: " . $item['Product']['Title'] . "\n";
        //     $message .= "Quantity: " . $item['Quantity'] . "\n";
        //     $message .= "Total Price: " . $item['TotalPrice'] . " " . $response['Data']['Currency'] . "\n";
        //     $message .= "Tax Amount: " . $item['TaxIndex'] . " " . $response['Data']['Currency'] . "\n";
        //     $message .= "Discount: " . $item['Discount'] . " " . $response['Data']['Currency'] . "\n\n";
        // }


        // \Log::info('Data Response RIGHT BBBBBBBBBBBBB', [$message]);


        $orderItems = $response['Data']['OrderItems'][0] ?? null; // Get first item or null

        if ($orderItems) {
            $message = [
                'Product' => $orderItems['Product']['Title'],
                'Quantity' => $orderItems['Quantity'],
                'Total Price' => $orderItems['TotalPrice'] . " " . $response['Data']['Currency'],
                'Tax Amount' => $orderItems['TaxIndex'] . " " . $response['Data']['Currency'],
                'Discount' => $orderItems['Discount'] . " " . $response['Data']['Currency'],
            ];
        } else {
            $message = ['error' => 'No order items found'];
        }

        \Log::info('Data Response RIGHT BBBBBBBBBBBBB', $message);


        return response()->json([
            "results" => [
                [
                    "toolCallId" => $tool_call_id,
                    "result" => $message
                ]
            ]
        ], 200);
    }
















    // public function getOrder111($id)
    // {
    //     \Log::info('API hit ho gai he');
    //     if (!$id || !is_numeric($id)) {
    //         return response()->json([
    //             'error' => true,
    //             'message' => 'Valid order ID is required'
    //         ], 400);
    //     }

    //     $username = env('BILLBEE_USERNAME', 'info@tilltools.de');
    //     $password = env('BILLBEE_PASSWORD', 'kadfniHu7894*!');
    //     $apiKey = env('BILLBEE_API_KEY', '21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8');

    //     $ch = curl_init();

    //     curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders/' . $id);
    //     curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    //     curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
    //     curl_setopt($ch, CURLOPT_TIMEOUT, 30); // Add timeout
    //     curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true); // Verify SSL for security

    //     $headers = [
    //         'Authorization: Basic ' . base64_encode($username . ':' . $password),
    //         'X-Billbee-Api-Key: ' . $apiKey,
    //         'Content-Type: application/json',
    //         'Accept: application/json'
    //     ];
    //     curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    //     $result = curl_exec($ch);
    //     $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

    //     // Check for errors
    //     if (curl_errno($ch)) {
    //         $error = curl_error($ch);
    //         curl_close($ch);
    //         \Log::error('Billbee API cURL error:', ['error' => $error, 'order_id' => $id]);
    //         return response()->json([
    //             'error' => true,
    //             'message' => 'API request failed: ' . $error
    //         ], 500);
    //     }

    //     curl_close($ch);

    //     $response = json_decode($result, true);

    //     if ($httpCode >= 400) {
    //         $errorMessage = isset($response->ErrorMessage) ? $response->ErrorMessage : 'Unknown error';
    //         \Log::error('Billbee API error:', [
    //             'code' => $httpCode,
    //             'message' => $errorMessage,
    //             'order_id' => $id
    //         ]);

    //         if ($httpCode == 404) {
    //             return response()->json([
    //                 'error' => true,
    //                 'message' => 'Order not found'
    //             ], 404);
    //         }

    //         return response()->json([
    //             'error' => true,
    //             'message' => $errorMessage
    //         ], $httpCode);
    //     }


    //     if ($response === null) {
    //         \Log::error('Billbee API invalid response:', ['order_id' => $id]);
    //         return response()->json([
    //             'error' => true,
    //             'message' => 'Invalid API response'
    //         ], 500);
    //     }
    //     \Log::info('REPONSEIS ->>>>>    aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa', [$response]);

    //     $orderItems = $response['Data']['OrderItems'];

    //     $message = "Your order has been successfully processed! Here are the details:\n\n";

    //     foreach ($orderItems as $item) {
    //         $message .= "Product: " . $item['Product']['Title'] . "\n";
    //         $message .= "Quantity: " . $item['Quantity'] . "\n";
    //         $message .= "Total Price: " . $item['TotalPrice'] . " " . $response['Data']['Currency'] . "\n";
    //         $message .= "Tax Amount: " . $item['TaxIndex'] . " " . $response['Data']['Currency'] . "\n";
    //         $message .= "Discount: " . $item['Discount'] . " " . $response['Data']['Currency'] . "\n\n";
    //     }


    //     \Log::info('Data Response RIGHT BBBBBBBBBBBBB', [$message]);



    //     return response()->json([
    //         "results" => [
    //             [
    //                 // "toolCallId" => $tool_call_id,
    //                 "result" => $message
    //             ]
    //         ]
    //     ], 200);



    // }

}


























    // public function getOrder($id)
    // {
    //     $ch = curl_init();

    //     curl_setopt($ch, CURLOPT_URL, 'https://app.billbee.io/api/v1/orders/' . $id);
    //     curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    //     curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');

    //     $headers = array();


    //     $headers[] = 'Authorization: Basic ' . base64_encode('info@tilltools.de:kadfniHu7894*!');
    //     $headers[] = 'Content-Type: application/json';
    //     $headers[] = 'X-Billbee-Api-Key: 21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8';
    //     $headers[] = 'Accept: application/json';
    //     curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    //     $result = curl_exec($ch);
    //     if (curl_errno($ch)) {
    //         echo 'Error:' . curl_error($ch);
    //     }
    //     curl_close($ch);

    //     return json_decode($result);
    // }
