<?php

namespace App\Jobs;

use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Queue\Queueable;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use Illuminate\Support\Facades\Mail;
use App\Mail\SendInqueryMail;

class SendInqueryJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    protected $createProductInqury;
    protected $admin_email;
    /**
     * Create a new job instance.
     */
    public function __construct($createProductInqury,$admin_email)
    {
        $this->createProductInqury = $createProductInqury;
        $this->admin_email = $admin_email;
    }

    /**
     * Execute the job.
     */

    public function handle(): void
    {
        Mail::to($this->admin_email)->send(new SendInqueryMail($this->createProductInqury));
    }
}
