<?php

namespace App\Traits;
use BillbeeDe\BillbeeAPI\Client;
use GuzzleHttp\Client as GuzzleClient;
use Illuminate\Support\Facades\Log;
use Psr\Log\LoggerInterface;

trait Billbee
{
    protected ?Client $billbee = null;
    protected ?GuzzleClient $httpClient = null;

    protected function billbee(): Client
    {
        if (!$this->billbee) {
            // Create with just the required parameters
            $this->billbee = new Client(
                "info@tilltools.de",     // username
                "kadfniHu7894*!",        // password
                "21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8"  // apiKey
            );
        }

        return $this->billbee;
    }

    protected function billbeeRaw(string $endpoint, string $method = 'GET', array $params = [])
    {
        if (!$this->httpClient) {
            $this->httpClient = new GuzzleClient([
                'base_uri' => 'https://app.billbee.io/api/v1/',
                'headers' => [
                    'Authorization' => 'Basic ' . base64_encode('info@tilltools.de:kadfniHu7894*!'),
                    'Content-Type' => 'application/json',
                    'X-Billbee-Api-Key' => '21DBBDA7-5DE5-40C6-8D6D-4BFAE3A964A8',
                    'Accept' => 'application/json'
                ]
            ]);
        }

        try {
            $response = $this->httpClient->request($method, $endpoint, [
                'query' => $method === 'GET' ? $params : null,
                'json' => $method !== 'GET' ? $params : null,
            ]);

            return json_decode($response->getBody()->getContents(), true);
        } catch (\Exception $e) {
            Log::error('Billbee Raw Error', [
                'message' => $e->getMessage(),
                'code' => $e->getCode()
            ]);
            return null;
        }
    }

    protected function handleSdkResponse($response)
    {
        if (is_object($response)) {
            // Convert SDK response object to array
            return [
                'paging' => $response->paging ?? null,
                'data' => $response->data ?? [],
                'errorMessage' => $response->errorMessage ?? null,
                'errorCode' => $response->errorCode ?? 0
            ];
        }
        return $response;
    }
}
